VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private mUSBDevHandle    As usb_dev_handle
Private mCountUSBBusses  As Long
Private mUSBBus          As LibUSB0Bus
'Private mUSBBusses       As Collection 'speichert LibUSB0Bus-Objekte
Private mCountUSBDevices As Long
'Private mUSBDevices      As Collection 'speichert LibUSB0Device-Objekte
Private mUSBVersion      As LibUSB0Version 'usb_version

Private Sub Class_Initialize()
    
    'zuerst alle Zeigerklassen erstellen
    Set mUSBBus = New LibUSB0Bus
    Set mUSBVersion = New LibUSB0Version
    
    Call usb_init
    'Dim p As Long
    'p = 0
    'Call usb_set_debug(0) 'falsche Aufrufkonvention!
    mCountUSBBusses = usb_find_busses
    mCountUSBDevices = usb_find_devices
    
    mUSBBus.Ptr = usb_get_busses
    
    mUSBVersion.Ptr = usb_get_version
    
End Sub

Private Sub Class_Terminate()
    'Call usb_close(mUSBDevHandle)
End Sub

Public Function ToString() As String
    Dim s As String
    s = s & "CountUSBBusses : " & CStr(mCountUSBBusses) & vbCrLf & _
            "CountUSBDevices: " & CStr(mCountUSBDevices) & vbCrLf & _
            mUSBVersion.ToString
    'Dim i As Long
    s = s & mUSBBus.ToString
    'For i = 0 To mCountUSBBusses - 1
        
    'Next
    
    ToString = s
End Function

