VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0ConfigDescriptor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBConfigDesc
    pudt As TUDTPtr
    p()  As usb_config_descriptor
End Type
Private Const C_LenB_config_desc As Long = 32
Private mUSBConfigDesc As PUSBConfigDesc

Private Sub Class_Initialize()
    Call InitPtr
End Sub

Private Sub Class_Terminate()
  'der ArrPtr mu hier nicht gelscht werden, denn der Speicher mu ohnehin freigegeben werden VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBConfigDesc
       Call New_UDTPtr(.pudt, _
                       FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                       C_LenB_config_desc)
       Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    If RHS = 0 Then Exit Property
    mUSBConfigDesc.pudt.pvData = RHS
End Property

'Tja hier knnte das packed probleme bereiten
'Public Type usb_config_descriptor
'  bLength             As Byte    '1'unsigned char
'  bDescriptorType     As Byte    '1
'  wTotalLength        As Integer '2 'unsigned short
'  bNumInterfaces      As Byte    '1
'  bConfigurationValue As Byte    '1
'  iConfiguration      As Byte    '1
'  bmAttributes        As Byte    '1
'  MaxPower            As Byte    '1
'  pUsb_interface      As Long    '4 ' pointer to a struct usb_interface *interface;
'  pExtra              As Long    '4 ' pointer to unsigned char *extra; '/* Extra descriptors */
'  extralen            As Long    '4
'End Type                    'SUM: 21 '??? oh shit why so bescheuert?

Public Function ToString() As String
    Dim s As String
    If mUSBConfigDesc.pudt.pvData = 0 Then Exit Function
    With mUSBConfigDesc.p(0)
        s = s & "          USBConfigDesc:bLength:              " & CStr(.bLength) & vbCrLf
        s = s & "          USBConfigDesc:bDescriptorType:      " & CStr(.bDescriptorType) & vbCrLf
        s = s & "          USBConfigDesc:wTotalLength:         " & CStr(.wTotalLength) & vbCrLf
        s = s & "          USBConfigDesc:bNumInterfaces:       " & CStr(.bNumInterfaces) & vbCrLf
        s = s & "          USBConfigDesc:bConfigurationValue:  " & CStr(.bConfigurationValue) & vbCrLf
        s = s & "          USBConfigDesc:iConfiguration:       " & CStr(.iConfiguration) & vbCrLf
        s = s & "          USBConfigDesc:bmAttributes:         " & Hex$(.bmAttributes) & vbCrLf
        s = s & "          USBConfigDesc:MaxPower:             " & CStr(.MaxPower) & vbCrLf
        s = s & "          USBConfigDesc:pUsb_interface:       " & Hex$(.pUsb_interface) & vbCrLf
        s = s & "          USBConfigDesc:pExtra:               " & Hex$(.pExtra) & vbCrLf
        s = s & "          USBConfigDesc:extralen:             " & CStr(.extralen) & vbCrLf
    End With
    ToString = s
End Function


