VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0DeviceDescriptor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBDeviceDesc
    pudt As TUDTPtr
    p()  As usb_device_descriptor
End Type
Private Const C_LenB_usb_device_descriptor As Long = 32
Private mUSBDeviceDesc As PUSBDeviceDesc

Private Sub Class_Initialize()
    Call InitPtr
End Sub

Private Sub Class_Terminate()
  'der ArrPtr mu hier nicht gelscht werden, denn der Speicher mu ohnehin freigegeben werden VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBDeviceDesc
       Call New_UDTPtr(.pudt, _
                       FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                       C_LenB_usb_device_descriptor)
       Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    If RHS = 0 Then Exit Property
    mUSBDeviceDesc.pudt.pvData = RHS
End Property

'Public Type usb_device_descriptor
'  bLength             As Byte    '1   'unsigned char
'  bDescriptorType     As Byte    '1
'  bcdUSB              As Integer '2 'unsigned short
'  bDeviceClass        As Byte    '1
'  bDeviceSubClass     As Byte    '1
'  bDeviceProtocol     As Byte    '1
'  bMaxPacketSize0     As Byte    '1
'  idVendor            As Integer '2
'  idProduct           As Integer '2
'  bcdDevice           As Integer '2
'  iManufacturer       As Byte    '1
'  iProduct            As Byte    '1
'  iSerialNumber       As Byte    '1
'  bNumConfigurations  As Byte    '1
'End Type                'SUM:    18 'geht das? das kann Probleme machen

Public Function ToString() As String
    Dim s As String
    If mUSBDeviceDesc.pudt.pvData = 0 Then Exit Function
    With mUSBDeviceDesc.p(0)
        s = s & "        mUSBDeviceDesc:bLength:            " & CStr(.bLength) & vbCrLf
        s = s & "        mUSBDeviceDesc:bDescriptorType:    " & CStr(.bDescriptorType) & vbCrLf
        s = s & "        mUSBDeviceDesc:bcdUSB:             " & CStr(.bcdUSB) & vbCrLf
        s = s & "        mUSBDeviceDesc:bDeviceClass:       " & CStr(.bDeviceClass) & vbCrLf
        s = s & "        mUSBDeviceDesc:bDeviceProtocol:    " & CStr(.bDeviceProtocol) & vbCrLf
        s = s & "        mUSBDeviceDesc:bMaxPacketSize0:    " & CStr(.bMaxPacketSize0) & vbCrLf
        s = s & "        mUSBDeviceDesc:idVendor:           " & Hex$(.idVendor) & vbCrLf
        s = s & "        mUSBDeviceDesc:idProduct:          " & Hex$(.idProduct) & vbCrLf
        s = s & "        mUSBDeviceDesc:bcdDevice:          " & CStr(.bcdDevice) & vbCrLf
        s = s & "        mUSBDeviceDesc:iManufacturer:      " & CStr(.iManufacturer) & vbCrLf
        s = s & "        mUSBDeviceDesc:iProduct:           " & CStr(.iProduct) & vbCrLf
        s = s & "        mUSBDeviceDesc:iSerialNumber:      " & CStr(.iSerialNumber) & vbCrLf
        s = s & "        mUSBDeviceDesc:bNumConfigurations: " & CStr(.bNumConfigurations) & vbCrLf
    End With
    ToString = s
End Function


