VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0EndpointDescriptor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBEndpointDesc
    pudt As TUDTPtr
    p()  As usb_endpoint_descriptor
End Type
Private Const C_LenB_usb_endpoint_descriptor As Long = 32
Private mUSBEndpointDesc As PUSBEndpointDesc

Private Sub Class_Initialize()
    Call InitPtr
End Sub

Private Sub Class_Terminate()
'der ArrPtr mu hier nicht gelscht werden, denn der Speicher mu ohnehin freigegeben werden VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBEndpointDesc
       Call New_UDTPtr(.pudt, _
                       FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                       C_LenB_usb_endpoint_descriptor)
       Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    If RHS = 0 Then Exit Property
    mUSBEndpointDesc.pudt.pvData = RHS
End Property

'Public Type usb_endpoint_descriptor
'  bLength             As Byte    '1 'unsigned char
'  bDescriptorType     As Byte    '1
'  bEndpointAddress    As Byte    '1
'  bmAttributes        As Byte    '1
'  wMaxPacketSize      As Integer '2 'unsigned short
'  bInterval           As Byte    '1
'  bRefresh            As Byte    '1
'  bSynchAddress       As Byte    '1
'  pExtra              As Long    '4 'unsigned char *extra; /* Extra descriptors */ 'oder As String?
'  extralen            As Long    '4
'End Type                   'SUM: 17 'really ??? why so bescheuert?
Public Function ToString() As String
    Dim s As String
    If mUSBEndpointDesc.pudt.pvData = 0 Then Exit Function
    With mUSBEndpointDesc.p(0)
        s = s & "      bEndpointAddress: " & Hex$(.bEndpointAddress) & vbCrLf
        s = s & "      bmAttributes:     " & Hex$(.bmAttributes) & vbCrLf
        s = s & "      wMaxPacketSize:   " & CStr(.wMaxPacketSize) & vbCrLf
        s = s & "      bInterval:        " & CStr(.bInterval) & vbCrLf
        s = s & "      bRefresh:         " & CStr(.bRefresh) & vbCrLf
        s = s & "      bSynchAddress:    " & CStr(.bSynchAddress) & vbCrLf
    End With
    ToString = s
End Function



