VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0Bus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBBus
    pudt As TUDTPtr
    p()  As usb_bus
End Type
Private Const C_LenB_usb_bus As Long = 32
Private mUSBBus As PUSBBus
Private mUSBDevice As LibUSB0Device

Private Sub Class_Initialize()
    Call InitPtr
    Set mUSBDevice = New LibUSB0Device
End Sub

Private Sub Class_Terminate()
  'der ArrPtr mu hier nicht gelscht werden, denn der Speicher mu ohnehin freigegeben werden VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBBus
       Call New_UDTPtr(.pudt, _
                       FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                       C_LenB_usb_bus)
       Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    If RHS = 0 Then Exit Property
    With mUSBBus
        With .pudt
            .pvData = RHS
        End With
        With .p(0)
            mUSBDevice.Ptr = .devices
        End With
    End With
End Property
'Public Type usb_bus
'  next                As Long      '4 'pointer to the next usb_bus
'  prev                As Long      '4 'pointer to the previous usb_bus
'  dirname(0 To LIBUSB_PATH_MAX - 1) As Byte '512
'  devices             As Long      '4 'pointer to the first usb_device
'  location            As Long      '4 'Int64
'  pRoot_dev           As Long      '4 'pointer to a usb_device
'End Type                    'SUM: 532 '528
'
Public Function ToString() As String
    Dim s As String
    If mUSBBus.pudt.pvData = 0 Then Exit Function
    With mUSBBus.p(0)
        s = s & "    USBBus:next:      " & CStr(.next) & vbCrLf
        s = s & "    USBBus:prev:      " & CStr(.prev) & vbCrLf
        s = s & "    USBBus:dirname:   " & ByteArrToString(.dirname) & vbCrLf
        s = s & "    USBBus:devices:   " & Hex$(.devices) & vbCrLf
        s = s & "    USBBus:location:  " & Hex$(.location) & vbCrLf
        s = s & "    USBBus:pRoot_dev: " & Hex$(.pRoot_dev) & vbCrLf
        s = s & mUSBDevice.ToString
    End With
    ToString = s
End Function

