VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0Device"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBDevice
    pudt As TUDTPtr
    p()  As usb_device
End Type
Private Const C_LenB_usb_device As Long = 32
Private mUSBDevice As PUSBDevice
Private mUSBDevHandle As usb_dev_handle 'Long
Private mUSBDeviceDesc As LibUSB0DeviceDescriptor
Private mUSBConfigDesc As LibUSB0ConfigDescriptor

Private Sub Class_Initialize()
    Call InitPtr
    Set mUSBDeviceDesc = New LibUSB0DeviceDescriptor
    Set mUSBConfigDesc = New LibUSB0ConfigDescriptor
End Sub

Private Sub Class_Terminate()
  'der ArrPtr mu hier nicht gelscht werden, denn der Speicher mu ohnehin freigegeben werden VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBDevice
       Call New_UDTPtr(.pudt, _
                       FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                       C_LenB_usb_device)
       Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    Dim p As Long
    If RHS = 0 Then Exit Property
    With mUSBDevice
        With .pudt
            .pvData = RHS
        End With
        With .p(0)
            mUSBDeviceDesc.Ptr = VarPtr(.Descriptor)
            Call RtlMoveMemory(p, ByVal VarPtr(.Config) - 2, 4)
            If p <> 0 Then
                mUSBConfigDesc.Ptr = p
            End If
        End With
    End With
    'falsche dll-Aufrufkonvention
    'mUSBDevHandle = usb_open(RHS)
End Property

'Public Type usb_device
'  next                As Long  '4 'pointer to the next USB_Device
'  prev                As Long  '4 'pointer to the previous USB_Device
'  filename(0 To LIBUSB_PATH_MAX - 1) As Byte '512
'  Bus                 As Long  '4 'pointer to the parent USB_Bus
'  Descriptor          As usb_device_descriptor '18 'here it is not a pointer to a usb_device_Descriptor
'  Config              As integer '2 'pointer to a USB_Config_Descriptor
'  pDev                As Long  '4 pointer to void  'Darwin support ???
'  devnum              As Byte  '1
'  num_children        As Byte  '1
'  ppChildren          As Long  '4 'pointer to a pointer to a usb_device
'End Type              'SUM:   556

Public Function ToString() As String
    Dim s As String
    If mUSBDevice.pudt.pvData = 0 Then Exit Function
    With mUSBDevice.p(0)
        s = s & "      USBDevice:next:         " & Hex$(.next) & vbCrLf
        s = s & "      USBDevice:prev:         " & Hex$(.prev) & vbCrLf
        s = s & "      USBDevice:filename:     " & ByteArrToString(.filename) & vbCrLf
        s = s & "      USBDevice:Bus:          " & Hex$(.Bus) & vbCrLf
        s = s & mUSBDeviceDesc.ToString
        s = s & "      USBDevice:Config:       " & CStr(.Config) & vbCrLf
        s = s & mUSBConfigDesc.ToString
        s = s & "      USBDevice:pDev:         " & Hex$(.pDev) & vbCrLf
        s = s & "      USBDevice:devnum:       " & CStr(.devnum) & vbCrLf
        s = s & "      USBDevice:num_children: " & CStr(.num_children) & vbCrLf
        s = s & "      USBDevice:ppChildren:   " & Hex$(.ppChildren) & vbCrLf
    End With
    ToString = s
End Function


