VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0InterfaceDescriptor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBInterfaceDesc
    pudt As TUDTPtr
    p()  As usb_interface_descriptor
End Type
Private Const C_LenB_usb_interface_descriptor As Long = 32
Private mUSBInterfaceDesc As PUSBInterfaceDesc

Private Sub Class_Initialize()
    Call InitPtr
End Sub

Private Sub Class_Terminate()
  'der ArrPtr mu hier nicht gelscht werden, denn der Speicher mu ohnehin freigegeben werden VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBInterfaceDesc
       Call New_UDTPtr(.pudt, _
                       FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                       C_LenB_usb_interface_descriptor)
       Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    If RHS = 0 Then Exit Property
    mUSBInterfaceDesc.pudt.pvData = RHS
End Property

Public Function ToString() As String
    Dim s As String
    With mUSBInterfaceDesc.p(0)
        s = s & "    bInterfaceNumber:   " & CStr(.bInterfaceNumber) & vbCrLf
        s = s & "    bAlternateSetting:  " & CStr(.bAlternateSetting) & vbCrLf
        s = s & "    bNumEndpoints:      " & CStr(.bNumEndpoints) & vbCrLf
        s = s & "    bInterfaceClass:    " & CStr(.bInterfaceClass) & vbCrLf
        s = s & "    bInterfaceSubClass: " & CStr(.bInterfaceSubClass) & vbCrLf
        s = s & "    bInterfaceProtocol: " & CStr(.bInterfaceProtocol) & vbCrLf
        s = s & "    iInterface:         " & CStr(.iInterface) & vbCrLf
    End With
    ToString = s
End Function



