VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LibUSB0Version"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type PUSBVersion
    pudt As TUDTPtr
    p() As usb_version
End Type
Private Const C_LenB_usb_version As Long = 32
Private mUSBVersion As PUSBVersion

Private Sub Class_Initialize()
    Call InitPtr
End Sub

Private Sub Class_Terminate()
  'der ArrPtr mu hier nicht gelscht werden,
  'denn der Speicher mu ohnehin freigegeben werden
  'VB kann das dafr bernehmen
End Sub

Private Sub InitPtr()
    With mUSBVersion
        Call New_UDTPtr(.pudt, _
                        FADF_AUTO Or FADF_FIXEDSIZE Or FADF_RECORD, _
                        C_LenB_usb_version)
        Call RtlMoveMemory(ByVal ArrPtr(.p), ByVal VarPtr(.pudt), 4)
    End With
End Sub

Public Property Let Ptr(RHS As Long)
    If RHS = 0 Then Exit Property
    mUSBVersion.pudt.pvData = RHS
End Property

Public Function ToString() As String
    Dim s As String
    With mUSBVersion.p(0) ': s = s & "USBVersion: " & vbCrLf
        s = s & "DLL version:    " & usb_version_ToString(.dll)
        s = s & "Driver version: " & usb_version_ToString(.driver)
    End With
    ToString = s
End Function

Private Function usb_version_ToString(v As usb_version_) As String
    Dim s As String
    With v
        s = s & CStr(.major) & "."
        s = s & CStr(.minor) & "."
        s = s & CStr(.micro) & "."
        s = s & CStr(.nano) & vbCrLf
    End With
    usb_version_ToString = s
End Function
